<?php

namespace app\admin\controller;

use app\common\controller\Backend;

/**
 * 用户优惠券核销记录
 *
 * @icon fa fa-circle-o
 */
class UserCouponsLog extends Backend
{

    /**
     * UserCouponsLog模型对象
     * @var \app\admin\model\UserCouponsLog
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\UserCouponsLog;

    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            //只能看自己的
            $where_op = [];
            if($this->auth->company_id){
                $where_op['user_coupons_log.company_id'] = $this->auth->company_id;
            }

            $list = $this->model
                    ->with(['company','user','coupons','staff'])
                    ->where($where)
                    ->where($where_op)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('company')->visible(['name']);
				$row->getRelation('user')->visible(['nickname']);
				$row->getRelation('coupons')->visible(['name','info','days']);
				$row->getRelation('staff')->visible(['truename']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

}
