define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'recharge_gift/index/config_id/' + Config.config_id + location.search,
                    add_url: 'recharge_gift/add/config_id/'+ Config.config_id,
                    edit_url: 'recharge_gift/edit',
                    del_url: 'recharge_gift/del',
                    multi_url: 'recharge_gift/multi',
                    import_url: 'recharge_gift/import',
                    table: 'recharge_gift',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                search:false,
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'config_id', title: __('Config_id')},
                        {field: 'number', title: __('Number'),operate: false},
                        {field: 'coupon_id', title: __('Coupon_id'), operate: false},
                        {field: 'coupons.name', title: __('Coupons.name'), operate: 'LIKE'},
                        {field: 'coupons.info', title: __('Coupons.info'), operate: false},
                        {field: 'coupons.days', title: __('Coupons.days'), operate: false},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});
