define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'servicetype/index' + location.search,
                    add_url: 'servicetype/add',
                    edit_url: 'servicetype/edit',
//                    del_url: 'servicetype/del',
                    multi_url: 'servicetype/multi',
                    import_url: 'servicetype/import',
                    table: 'servicetype',
                    dragsort_url:false
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'weigh',
                search:false,
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'title', title: __('Title'), operate: 'LIKE'},
                        {field: 'weigh', title: __('Weigh'), operate: false},
                        {field: 'baoyang_switch', title: __('Baoyang_switch'), searchList: {"1":__('Baoyang_switch 1'),"0":__('Baoyang_switch 0')}, table: table, formatter: Table.api.formatter.toggle},
                        {field: 'is_upkeep', title: __('Is_upkeep'), searchList: {"1":__('Is_upkeep 1'),"0":__('Is_upkeep 0')}, formatter: Table.api.formatter.normal},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});
